﻿using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Import
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 키 상태 구하기 - GetKeyState(keyCode)

        /// <summary>
        /// 키 상태 구하기
        /// </summary>
        /// <param name="keyCode">키 코드</param>
        /// <returns>키 상태</returns>
        [DllImport("user32")]
        private static extern short GetKeyState(int keyCode);

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// VK_CAPITAL
        /// </summary>
        private const int VK_CAPITAL = 0x14;

        /// <summary>
        /// VK_NUMLOCK
        /// </summary>
        private const int VK_NUMLOCK = 0x90;

        /// <summary>
        /// VK_SCROLL
        /// </summary>
        private const int VK_SCROLL = 0x91;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            while(true)
            {
                bool scrollLock = Convert.ToBoolean(GetKeyState(VK_SCROLL ) & 1);
                bool numLock    = Convert.ToBoolean(GetKeyState(VK_NUMLOCK) & 1);
                bool capsLock   = Convert.ToBoolean(GetKeyState(VK_CAPITAL) & 1);

                if(scrollLock)
                {
                    Console.WriteLine("SCROLL LOCK ON");
                }

                if(numLock)
                {
                    Console.WriteLine("NUM LOCK ON");
                }

                if(capsLock)
                {
                    Console.WriteLine("CAPS LOCK ON");
                }

                Thread.Sleep(500);
            }
        }

        #endregion
    }
}